Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/PerformanceModelingView.Designer.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/PerformanceModelingView.Designer.cs	(revision 13787)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/PerformanceModelingView.Designer.cs	(revision 13787)
@@ -0,0 +1,210 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.OptimizationExpertSystem {
+  partial class PerformanceModelingView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.recommenderLabel = new System.Windows.Forms.Label();
+      this.recommenderComboBox = new System.Windows.Forms.ComboBox();
+      this.recommendStartButton = new System.Windows.Forms.Button();
+      this.tabControl = new System.Windows.Forms.TabControl();
+      this.characteristicsTabPage = new System.Windows.Forms.TabPage();
+      this.refreshCharacteristicsButton = new System.Windows.Forms.Button();
+      this.parametersTabPage = new System.Windows.Forms.TabPage();
+      this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
+      this.resultsTabPage = new System.Windows.Forms.TabPage();
+      this.characteristicsViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.tabControl.SuspendLayout();
+      this.characteristicsTabPage.SuspendLayout();
+      this.parametersTabPage.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // recommenderLabel
+      // 
+      this.recommenderLabel.AutoSize = true;
+      this.recommenderLabel.Location = new System.Drawing.Point(5, 6);
+      this.recommenderLabel.Name = "recommenderLabel";
+      this.recommenderLabel.Size = new System.Drawing.Size(79, 13);
+      this.recommenderLabel.TabIndex = 12;
+      this.recommenderLabel.Text = "Recommender:";
+      // 
+      // recommenderComboBox
+      // 
+      this.recommenderComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.recommenderComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.recommenderComboBox.FormattingEnabled = true;
+      this.recommenderComboBox.Location = new System.Drawing.Point(90, 3);
+      this.recommenderComboBox.Name = "recommenderComboBox";
+      this.recommenderComboBox.Size = new System.Drawing.Size(264, 21);
+      this.recommenderComboBox.TabIndex = 11;
+      this.recommenderComboBox.SelectedIndexChanged += new System.EventHandler(this.RecommenderComboBoxOnSelectedIndexChanged);
+      // 
+      // recommendStartButton
+      // 
+      this.recommendStartButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.recommendStartButton.Location = new System.Drawing.Point(360, 3);
+      this.recommendStartButton.Name = "recommendStartButton";
+      this.recommendStartButton.Size = new System.Drawing.Size(26, 23);
+      this.recommendStartButton.TabIndex = 13;
+      this.recommendStartButton.Text = "Start";
+      this.recommendStartButton.UseVisualStyleBackColor = true;
+      this.recommendStartButton.Click += new System.EventHandler(this.RecommendStartButtonOnClick);
+      // 
+      // tabControl
+      // 
+      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.tabControl.Controls.Add(this.characteristicsTabPage);
+      this.tabControl.Controls.Add(this.parametersTabPage);
+      this.tabControl.Controls.Add(this.resultsTabPage);
+      this.tabControl.Location = new System.Drawing.Point(0, 30);
+      this.tabControl.Name = "tabControl";
+      this.tabControl.SelectedIndex = 0;
+      this.tabControl.Size = new System.Drawing.Size(700, 350);
+      this.tabControl.TabIndex = 14;
+      // 
+      // characteristicsTabPage
+      // 
+      this.characteristicsTabPage.Controls.Add(this.characteristicsViewHost);
+      this.characteristicsTabPage.Controls.Add(this.refreshCharacteristicsButton);
+      this.characteristicsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.characteristicsTabPage.Name = "characteristicsTabPage";
+      this.characteristicsTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.characteristicsTabPage.Size = new System.Drawing.Size(692, 324);
+      this.characteristicsTabPage.TabIndex = 2;
+      this.characteristicsTabPage.Text = "Characteristics";
+      this.characteristicsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // refreshCharacteristicsButton
+      // 
+      this.refreshCharacteristicsButton.Location = new System.Drawing.Point(6, 6);
+      this.refreshCharacteristicsButton.Name = "refreshCharacteristicsButton";
+      this.refreshCharacteristicsButton.Size = new System.Drawing.Size(26, 23);
+      this.refreshCharacteristicsButton.TabIndex = 0;
+      this.refreshCharacteristicsButton.Text = "Refresh";
+      this.refreshCharacteristicsButton.UseVisualStyleBackColor = true;
+      this.refreshCharacteristicsButton.Click += new System.EventHandler(this.RefreshCharacteristicsButtonOnClick);
+      // 
+      // parametersTabPage
+      // 
+      this.parametersTabPage.Controls.Add(this.parameterCollectionView);
+      this.parametersTabPage.Location = new System.Drawing.Point(4, 22);
+      this.parametersTabPage.Name = "parametersTabPage";
+      this.parametersTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.parametersTabPage.Size = new System.Drawing.Size(692, 324);
+      this.parametersTabPage.TabIndex = 0;
+      this.parametersTabPage.Text = "Parameters";
+      this.parametersTabPage.UseVisualStyleBackColor = true;
+      // 
+      // parameterCollectionView
+      // 
+      this.parameterCollectionView.AllowEditingOfHiddenParameters = true;
+      this.parameterCollectionView.Caption = "ParameterCollection View";
+      this.parameterCollectionView.Content = null;
+      this.parameterCollectionView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.parameterCollectionView.Location = new System.Drawing.Point(3, 3);
+      this.parameterCollectionView.Name = "parameterCollectionView";
+      this.parameterCollectionView.ReadOnly = false;
+      this.parameterCollectionView.ShowDetails = true;
+      this.parameterCollectionView.Size = new System.Drawing.Size(686, 318);
+      this.parameterCollectionView.TabIndex = 0;
+      // 
+      // resultsTabPage
+      // 
+      this.resultsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.resultsTabPage.Name = "resultsTabPage";
+      this.resultsTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.resultsTabPage.Size = new System.Drawing.Size(692, 324);
+      this.resultsTabPage.TabIndex = 1;
+      this.resultsTabPage.Text = "Results";
+      this.resultsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // characteristicsViewHost
+      // 
+      this.characteristicsViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.characteristicsViewHost.Caption = "View";
+      this.characteristicsViewHost.Content = null;
+      this.characteristicsViewHost.Enabled = false;
+      this.characteristicsViewHost.Location = new System.Drawing.Point(6, 35);
+      this.characteristicsViewHost.Name = "characteristicsViewHost";
+      this.characteristicsViewHost.ReadOnly = false;
+      this.characteristicsViewHost.Size = new System.Drawing.Size(680, 283);
+      this.characteristicsViewHost.TabIndex = 1;
+      this.characteristicsViewHost.ViewsLabelVisible = true;
+      this.characteristicsViewHost.ViewType = null;
+      // 
+      // PerformanceModelingView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tabControl);
+      this.Controls.Add(this.recommenderLabel);
+      this.Controls.Add(this.recommenderComboBox);
+      this.Controls.Add(this.recommendStartButton);
+      this.Name = "PerformanceModelingView";
+      this.tabControl.ResumeLayout(false);
+      this.characteristicsTabPage.ResumeLayout(false);
+      this.parametersTabPage.ResumeLayout(false);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label recommenderLabel;
+    private System.Windows.Forms.ComboBox recommenderComboBox;
+    private System.Windows.Forms.Button recommendStartButton;
+    private System.Windows.Forms.TabControl tabControl;
+    private System.Windows.Forms.TabPage parametersTabPage;
+    private System.Windows.Forms.TabPage resultsTabPage;
+    private Core.Views.ParameterCollectionView parameterCollectionView;
+    private System.Windows.Forms.TabPage characteristicsTabPage;
+    private System.Windows.Forms.Button refreshCharacteristicsButton;
+    private MainForm.WindowsForms.ViewHost characteristicsViewHost;
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/PerformanceModelingView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/PerformanceModelingView.cs	(revision 13787)
+++ /branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/PerformanceModelingView.cs	(revision 13787)
@@ -0,0 +1,126 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common.Resources;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.MainForm;
+using HeuristicLab.OptimizationExpertSystem.Common;
+using HeuristicLab.PluginInfrastructure;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.OptimizationExpertSystem {
+  [View("Performance Modeling View")]
+  [Content(typeof(KnowledgeCenter), IsDefaultView = false)]
+  public partial class PerformanceModelingView : KnowledgeCenterViewBase {
+    private readonly CheckedItemList<StringValue> characteristics;
+
+    public PerformanceModelingView() {
+      InitializeComponent();
+      characteristics = new CheckedItemList<StringValue>();
+      characteristics.CheckedItemsChanged += CharacteristicsOnCheckedItemsChanged;
+      characteristicsViewHost.Content = characteristics;
+      recommendStartButton.Text = string.Empty;
+      recommendStartButton.Image = VSImageLibrary.Play;
+      refreshCharacteristicsButton.Text = string.Empty;
+      refreshCharacteristicsButton.Image = VSImageLibrary.Refresh;
+      UpdateRecommenderCombobox();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      UpdateCharacteristics();
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      // TODO: up/download state
+      recommendStartButton.Enabled = Content != null && recommenderComboBox.SelectedIndex >= 0 && characteristics.CheckedItems.Any();
+      characteristicsViewHost.Enabled = Content != null;
+    }
+
+    #region Update Controls
+    private void UpdateRecommenderCombobox() {
+      if (InvokeRequired) { Invoke((Action)UpdateRecommenderCombobox); return; }
+      var prevSelection = (IAlgorithmInstanceRecommender)recommenderComboBox.SelectedItem;
+      var prevNewIndex = -1;
+      recommenderComboBox.Items.Clear();
+
+      var i = 0;
+      foreach (var rcmd in ApplicationManager.Manager.GetInstances<IAlgorithmInstanceRecommender>()) {
+        recommenderComboBox.Items.Add(rcmd);
+        if (prevSelection == null || rcmd.GetType() == prevSelection.GetType())
+          prevNewIndex = prevSelection == null ? 0 : i;
+        i++;
+      }
+      
+      recommenderComboBox.SelectedIndex = prevNewIndex;
+    }
+
+    private void UpdateCharacteristics() {
+      if (InvokeRequired) { Invoke((Action)UpdateCharacteristics); return; }
+
+      var @checked = new HashSet<string>(characteristics.CheckedItems.Select(x => x.Value.Value));
+      characteristics.Clear();
+      if (Content == null || Content.ProblemInstances.Count == 0) return;
+
+      foreach (var c in Content.ProblemInstances.ResultNames) {
+        characteristics.Add(new StringValue(c), @checked.Contains(c));
+      }
+    }
+    #endregion
+
+    #region Content Event Handlers
+    protected override void OnProblemInstancesChanged() {
+      base.OnProblemInstancesChanged();
+      UpdateCharacteristics();
+      SetEnabledStateOfControls();
+    }
+    #endregion
+
+    #region Control Event Handlers
+    private void RecommenderComboBoxOnSelectedIndexChanged(object sender, EventArgs e) {
+      if (InvokeRequired) { Invoke((Action<object, EventArgs>)RecommenderComboBoxOnSelectedIndexChanged, sender, e); return; }
+      var rcmd = (IAlgorithmInstanceRecommender)recommenderComboBox.SelectedItem;
+      parameterCollectionView.Content = rcmd != null ? rcmd.Parameters : null;
+      SetEnabledStateOfControls();
+    }
+
+    private void RecommendStartButtonOnClick(object sender, EventArgs e) {
+      var rcmd = (IAlgorithmInstanceRecommender)recommenderComboBox.SelectedItem;
+      Content.RecommendationModel = rcmd.TrainModel(Content, characteristics.CheckedItems.Select(x => x.Value.Value).ToArray());
+    }
+
+    private void RefreshCharacteristicsButtonOnClick(object sender, EventArgs e) {
+      UpdateCharacteristics();
+      SetEnabledStateOfControls();
+    }
+    #endregion
+
+    #region Other Event Handlers
+    private void CharacteristicsOnCheckedItemsChanged(object sender, EventArgs e) {
+      SetEnabledStateOfControls();
+    }
+    #endregion
+  }
+}
